'// Params to be excluded from application url's during massaging. '|' is the separator
Const EXCLUSION_LIST_PARAMS = "regwiz"

'// OS Type. Mimiced from Mcinstall.
Const MCINST_OS_UNKNOWN = 0
Const MCINST_OS_WIN_95  = 1
Const MCINST_OS_WIN_98  = 2 
Const MCINST_OS_WIN_NT  = 3
Const MCINST_OS_WIN_2K  = 4
Const MCINST_OS_WIN_ME  = 5
Const MCINST_OS_WIN_XP  = 6

'// Error Code
Const MCINST_ADMIN_REQUIRED = 17

'// RegWiz Exe Wait State
Const REGWIZ_STATE_NORMAL	= 0
Const REGWIZ_STATE_INETWAIT = 1
Const REGWIZ_STATE_NEXTRUN  = 2

'//EXE name
Const MCAGENT_EXE		= "mcagent.exe"
Const MCDASH_EXE		= "mcdash.exe"
Const MCWELCOM_EXE		= "McWelCom.Exe"
Const STR_MCVSSHLDEXE	= "\mcvsshld.exe"
Const STR_MCAGENTEXE	= "\mcagent.exe"
Const STR_MCUPDATEEXE	= "\mcupdate.exe"
Const STR_MCWELCOMEXE	= "\mcwelcom.exe"
Const MCREGWIZ_EXE		= "McRegWiz.Exe"

'// RegWiz RunMode
Const CMDLINE_NOPARAM = 0
Const CMDLINE_EMBEDDING = 2
Const CMDLINE_AUTORUN = 4
Const CMDLINE_UPDATE = 8
Const CMDLINE_MASSAGE = 16
Const CMDLINE_PRODUCTSETUP = 32
Const CMDLINE_WOW = 64

Const MCREGWIZ_RUN_MODE				= "McRegWizRunMode"
Const REG_KEY_REGWIZ_BOOT_COUNT		= "RegWizBootCount"
Const REG_AGENT						= "HKLM\Software\McAfee.com\Agent"

'// CLSID
Const CLSID_MCAgent			= "{C7E39D60-7A9F-42bf-ABB1-03DC0FA4F493}"
Const CLSID_MCREGWIZ_EXE	= "{A1629739-6AE2-49f5-9A40-7FBD9CF5148F}"
Const CLSID_MCVSSHLD		= "{692E988D-1057-4c57-8078-26CF7AE54263}"
Const sLIC					= "{27CDC360-101B-48ff-96F0-8580AD849AAD}"

'// Directory names
Const REGWIZ_APP_DIR_NAME_WSLASH	=	"\RegApp"
Const REGWIZ_DIR_NAME_WSLASH		=	"\RegWiz"
Const MCAFEECOM_WSLASH				=	"\McAfee.com"
Const AGENT_WSLASH					=	"\Agent"
Const SHARED_WSLASH					=	"\Shared"
Const DATA_NEWS_DIR					=	"\Data"
Const COMMON_APP_DATA_DIR			=	"\McAfee.com\Agent"
Const AGENT_DIR_NAME				=	"\Agent"
Const VSO_DIR_NAME					=	"\VSO"

Const REG_VSO_KEY           = "HKLM\Software\McAfee.com\VirusScan Online"
Const REGKEY_AGENT_APPS		= "HKLM\Software\McAfee.com\Agent\Apps\"
Const REGKEY_RUN			= "HKLM\Software\Microsoft\Windows\CurrentVersion\Run"
Const REGKEY_MCREGWIZ		= "McRegWiz"
Const REG_INSTALL_DIR       = "Install Dir"
Const REG_RUNONCE_VSO		= "VirusScan Online"
Const REG_RUNONCE_WELCOME	= "McafWelcome"
Const REG_MCAGENT_KEY		= "McAgentExe"
Const REG_MCUPDATE_KEY		= "McUpdateExe"

Const MCREGWIZ_INTERFACE_NAME	= "McRegWizIFace"
Const MCREGWIZ_WAIT_STATE		= "McRegWizWaitState"

Const PROGRAMFILES_REGKEY   = "HKLM\Software\Microsoft\Windows\CurrentVersion"
Const PROGRAMFILES_VALNAME  = "ProgramFilesDir"

Const REG_WELCOME_KEY		 = "HKLM\Software\McAfee.com\Partner\Welcome"
Const REG_VALUENAME_NEXTPAGE = "NextPage"

Const REG_REGWIZ_KEY				= "HKLM\Software\McAfee.com\Agent\RegWiz"
Const REG_REGWIZ_URL_KEY			= "RegUrl"

Const REG_REGWIZ_LOG_KEY			= "HKLM\Software\McAfee.com\RegWiz\Installer"
Const REG_REGWIZ_LOG_COUNT_NAME		= "RegWizLogCount"
Const REG_REGWIZ_LOG_COUNT_PREFIX	= "RegWizLog#"

'// Special Folder ID
Const ID_COMMON_APP_DATA	= 35

'// Return Values

Const REGWIZ_SUCCESS			= 0
Const REGWIZ_ONREBOOT			= 1
Const REGWIZ_WHEN_CONNECTED		= 2
Const REGWIZ_ONREBOOT_CONNECTED	= 3
Const REGWIZ_NEXTRUN			= 4

'// Script internal return values
Const REGWIZ_STATUS_SUCCESS		= 0
Const REGWIZ_STATUS_NOINTERNET	= -1001

Const ERROR_HTM		= "error.htm"
Const UPROSET_HTM	= "uproset.htm"
Const PROFILE_HTM	= "profile.htm"
Const THANKYOU_HTM	= "thankyou.htm"
Const TERMS_HTM		= "terms.htm"
Const REMINDME_HTM	= "remind.htm"
Const REMCONFM_HTM	= "remconfm.htm"
Const FORCESUB_HTM	= "forcesub.htm"
Const INETCONRM_HTM	= "inetconrm.htm"
Const COMPLETION_HTM = "complete.htm"
Const SUBMITONCONNECT_HTM = "suboncon.htm"

Const OPTIN_HTM		= "optin.htm"
Const EULA_HTM		= "eula.htm"
Const CANCEL_HTM	= "thankyou.htm"

'// Property Names
Const PROP_VERSION		= "Version"
Const PROP_ACCOUNTID	= "AccountID"
Const PROP_WIZARDPARAM	= "WizardParam"
Const PROP_PROFILE		= "Profile"
Const PROP_APPLICATION	= "Application"
Const PROP_BACKEND		= "BackEnd"
Const PROP_REGURL		= "RegUrl"
Const PROP_CUSTOMID		= "CustomID"
Const PROP_LANGUAGE		= "Language"
Const PROP_SYNCURL		= "SyncUrl"
Const PROP_WEBSITE		= "WebSite"
Const PROP_EXPIRYDATE	= "ExpiryDate"
Const PROP_SUBTYPE		= "SubType"
Const PROP_SUBSTATUS	= "SubStatus"
Const PROP_APPCAT		= "AppCat"
Const PROP_APPCODE		= "AppCode"
Const PROP_AFFID		= "AffID"
Const PROP_COUNTRY		= "Country"
Const PROP_LANGCODE		= "LangCode"
Const PROP_CUSTOMDATA	= "CustomData"
Const PROP_FIRSTNAME	= "FirstName"
Const PROP_LASTNAME		= "LastName"
Const PROP_EMAILADDRESS	= "EmailAddress"
Const PROP_PASSWORD		= "Password"
Const PROP_RENEWURL		= "RenewUrl"
Const PROP_RESULT		= "Result"
Const PROP_TRIAL		= "IsTrial"
Const PROP_APPNAME		= "AppName"
Const PROP_APPDESC		= "AppDesc"
Const PROP_APPTRIALSUBDESC = "AppTrialSubDesc"

Const PROP_PERPETUAL	  = "Perpetual"
Const PROP_SETUP_URL	  = "ProfilePage"
Const PROP_TERMS_URL	  = "TermsPage"
Const PROP_FORCE_REG	  = "RegForce" 
Const PROP_CANCELWARN_URL = "CancelWarnPage"
Const PROP_REMINDME_URL   = "RemindMePage"
Const PROP_ACTIVATE_URL   = "ActivatePage"

Const PROP_REGRESPONSE	  = "RegResponse"
Const PROP_REGREQUEST	  = "RegRequest"
Const PROP_COMPLETION_URL = "CompletionURL"
Const PROP_COMPLETED_MSG  = "CompletedMsg"
Const PROP_SHOW_WOW		  = "ShowWOW"
Const PROP_OPTIN_ID		  = "optin_id_"

Const PROP_MULTIPRODUCT_REGISTER = "MultiProductRegister"
Const PROP_ERROR_CODE			 = "ErrorCode"

Const PROP_PRODNAME_TRIALSUB_DESC_HOLDER = "ProdNameTrialSubDescHolder"
Const PROP_PRODDESC_HOLDER = "ProdDescHolder"

Const PH_PRODUCTNAME = "{ProductName}"
Const PH_PRODUCTDESC = "{ProductDescription}"
Const PH_PRODUCTTRIALSUB = "{ProductName|Trial|Subscription}"

Const REGWIZ_VERSION = "3.0"

'// Server params
Dim MODE_AUTH, MODE_REG, MODE_LOGIN
MODE_AUTH	= "?ver=" & REGWIZ_VERSION & "&mode=auth&lcode=" & REGWIZ_LANG_ID
MODE_REG	= "?ver=" & REGWIZ_VERSION & "&mode=reg&lcode=" & REGWIZ_LANG_ID
MODE_LOGIN	= "?ver=" & REGWIZ_VERSION & "&mode=login&lcode=" & REGWIZ_LANG_ID

'// INI File, Section and Key Names
Const FACTORY_SETTINGS_INI	= "\rwconfig.ini"
Const OEM_INI_WSLASH		= "\oem.ini"
Const PROFILE_INI			= "\Profile.Ini"
Const MCREGWIZ_INI			= "\McRegWiz.Ini"

Const SECTION_SETTINGS		= "Settings"
Const SECTION_FREQUENCY		= "Frequency"
Const SECTION_REGWIZ		= "RegWiz"
Const SECTION_POSTREG		= "PostReg"

Const SECTION_USERPROFILE	= "UserProfile"	
Const SECTION_OPTIN			= "Optin"

Const SECTION_CUSTOM		= "custom"
Const SECTION_REGISTER		= "Register"

Const KEY_ACTION			= "Action"
Const KEY_DAYS				= "Days"
Const KEY_REG_FORCE			= "regforce"
Const KEY_SHOW_OPTIN		= "ShowOptin"
Const KEY_SHOW_EULA			= "ShowEula"

Const KEY_IGNORE_FORCE_PROFILE_SETUP		= "IgnoreForceInProfileSetup"

Const KEY_FIRSTNAME			= "FirstName"
Const KEY_LASTNAME			= "LastName"
Const KEY_EMAILADDRESS		= "EmailAddress"
Const KEY_PASSWORD			= "Password"
Const KEY_LANGUAGE			= "Language"
Const KEY_TRIAL				= "Trial"

Const KEY_WHENCONNECTED		= "WhenConnected"
Const KEY_NEXTRUN			= "NextRun"

Const KEY_CUSTOM_ID			= "customization_id"
Const KEY_APPID				= "app_id"
Const KEY_APPCODE			= "app_code"
Const KEY_AFFID				= "aff_id"
Const KEY_COUNTRY			= "country"
Const KEY_LANG				= "lang"
Const KEY_CUSTOMDATA		= "customdata"
Const KEY_APP_DESC			= "app_desc"
Const KEY_APP_NAME			= "app_name"
Const KEY_TRIALSUB_DESC		= "trialsub_desc"
Const KEY_PERPETUAL			= "Perpetual"

Const REGWIZ_UI_DLL_WCOLON_AND_NOSLASH	= "RegWizUI.dll::"
Const REGWIZ_UI_DLL_WCOLON	= "\RegWizUI.dll::"
Const PROTOCOL_MCP			= "mcp://"

'// FOR QA PURPOSE
Const REG_KEY_REGWIZ_QA		= "HKLM\Software\McAfee.com\Agent\QARegWiz"
Const REG_INTERNETOFF_QA	= "QAInternetOff"


