Option Explicit

Function CloseWindow()
'{
	If IsObject( gobjExternal ) Then
	'{
		gobjExternal.Close
		Set gobjExternal = Nothing
	'}
	Else
	'{
		window.close
	'}
	End If
'}
End Function

Function SetWizardStatus( nStatus )
'{
	If (Not gobjExternal Is Nothing) And IsObject(gobjExternal) Then
	'{
		gobjExternal.ReturnValue = nStatus
	'}
	End If
'}
End Function

Function SetExternalObject( ByRef objExternal )
'{
	Dim   nLastError

	On Error Resume Next  ' This is local for this function.

	Set objExternal = nothing
	SetExternalObject = False
	
	If IsObject( window.external ) And not window.external is nothing Then
	'{
		Set objExternal = window.external
		
		Err.Clear
		nLastError = Err.Number
		
		objExternal.ReturnValue = CLng(-1)
		If Err.Number <> nLastError Then
		'{
			Set objExternal = nothing
			Exit Function
		'}
		End If
		SetExternalObject = True
	'}
	End If
'}
End Function

Function GetProgramFilesDir()
'{
	Dim sProgramFilesDir

	sProgramFilesDir = gobjReg.RegQueryValue( PROGRAMFILES_REGKEY, PROGRAMFILES_VALNAME )
	If "" = sProgramFilesDir Then
	'{
		sProgramFilesDir = gobjOS.WindowsDirectory
		sProgramFilesDir = Left( sProgramFilesDir, InStr( sProgramFilesDir, ":" ) ) & PROGRAMFILES_DIR_NAME
	'}
	End If
	sProgramFilesDir = gobjFS.GetShortPathName (sProgramFilesDir)

	GetProgramFilesDir = sProgramFilesDir
'}
End Function

Function GetMcAfeeComDir()
'{
	Dim sMcAfeeComDir

	sMcAfeeComDir = GetProgramFilesDir()
	sMcAfeeComDir = sMcAfeeComDir & MCAFEECOM_WSLASH
	sMcAfeeComDir = gobjFS.GetShortPathName (sMcAfeeComDir)

	GetMcAfeeComDir = sMcAfeeComDir
'}
End Function

Function GetAgentDir()
'{
	Dim sAgentDir

	sAgentDir = gobjOS.GetObjectModuleDir(CLSID_MCAgent)

	If "" = sAgentDir Then
	'{
		sAgentDir = GetProgramFilesDir()
		sAgentDir = sAgentDir & AGENT_WSLASH
	'}
	End If
	sAgentDir = gobjFS.GetShortPathName (sAgentDir)

	GetAgentDir = sAgentDir
'}
End Function

Function GetSharedFolderDir()
'{
	Dim sSharedDir

	sSharedDir = GetMcAfeeComDir()
	sSharedDir = sSharedDir & SHARED_WSLASH
	sSharedDir = gobjFS.GetShortPathName (sSharedDir)

	GetSharedFolderDir = sSharedDir
'}
End Function

Function GetAgentDataDir()
'{
	Dim sAgentDataDir, sOSName, eOSType

	eOSType = gobjOS.GetOSInfo(sOSName)

	If MCINST_OS_WIN_XP <> eOSType Then
	'{
		sAgentDataDir = GetAgentDir() & DATA_NEWS_DIR
	'}
	Else
	'{
		Call gobjShell.GetSpecialFolderPath( ID_COMMON_APP_DATA, sAgentDataDir)
		sAgentDataDir = sAgentDataDir & COMMON_APP_DATA_DIR
	'}
	End If
	sAgentDataDir = gobjFS.GetShortPathName (sAgentDataDir)

	GetAgentDataDir = sAgentDataDir
'}
End Function

Function GetRegWizDir()
'{
	Dim sRegWizDir

	sRegWizDir = gobjOS.GetObjectModuleDir (CLSID_MCREGWIZ_EXE)

	If "" = sRegWizDir Then
	'{
		sRegWizDir = GetAgentDir()
		sRegWizDir = sRegWizDir & REGWIZ_DIR_NAME_WSLASH
	'}
	End If
	sRegWizDir = gobjFS.GetShortPathName (sRegWizDir)

	GetRegWizDir = sRegWizDir
'}
End Function

Function GetRegWizDataDir()
'{
	Dim sRegWizDataDir

	sRegWizDataDir = GetAgentDataDir()
	sRegWizDataDir = sRegWizDataDir & REGWIZ_DIR_NAME_WSLASH
	sRegWizDataDir = gobjFS.GetShortPathName (sRegWizDataDir)

	GetRegWizDataDir = sRegWizDataDir
'}
End Function

Function GetRegWizAppDir()
'{
	Dim sRegWizAppDir

	sRegWizAppDir = GetRegWizDataDir()
	sRegWizAppDir = sRegWizAppDir & REGWIZ_APP_DIR_NAME_WSLASH
	sRegWizAppDir = gobjFS.GetShortPathName (sRegWizAppDir)

	GetRegWizAppDir = sRegWizAppDir
'}
End Function

Function FormatNextRun( nDays )
'{
	Dim sDate, sYear, sMonth, sDay, sHour, sMin, sSeconds, CurDateTime

	CurDateTime = DateAdd ( "d", nDays, Now )

	sYear = Trim(CStr(Year(CurDateTime)))

	sMonth = Trim(CStr(Month(CurDateTime)))
	If Len(sMonth) <> 2 Then sMonth = "0" & sMonth

	sDay = Trim(CStr(Day(CurDateTime)))
	If Len(sDay) <> 2 Then sDay = "0" & sDay

	sHour = Trim(CStr(Hour(CurDateTime)))
	If Len(sHour) <> 2 Then sHour = "0" & sHour

	sMin = Trim(CStr(Minute(CurDateTime)))
	If Len(sMin) <> 2 Then sMin = "0" & sMin
	
	sSeconds = Trim(CStr(Second(CurDateTime)))
	If Len(sSeconds) <> 2 Then sSeconds = "0" & sSeconds

	sDate = sYear & ":" & sMonth & ":" & sDay & ":" & sHour & ":" & sMin & ":" & sSeconds

	FormatNextRun = sDate
'}
End Function

Function TestValues ( strPropName )
'{
	Dim objRequest, objProfile, objApplication, objWParam, objApps, objCData
	Dim AppsItems, cdk, cd, sVal
	Dim nCustDataCtr, nCount, nCtr

	Set objRequest = gobjExternal.GetParam ( strPropName )

	Set objProfile = Nothing
	Set objWParam  = Nothing 
	If PROP_REGREQUEST = strPropName Then
		Set objProfile = objRequest.Item (PROP_PROFILE)
		Set objWParam = objRequest.Item (PROP_WIZARDPARAM)
	End If

	Set objApplication = objRequest.Item (PROP_APPLICATION)

	sVal = "Version = " & objRequest.Item (PROP_VERSION) & vbCrLf
	sVal = sVal & "Account ID = " & objRequest.Item (PROP_ACCOUNTID) & vbCrLf & vbCrLf

	If objProfile Is Nothing Then
		sVal = sVal & "Profile is nothing" & vbCrLf & vbCrLf
	Else
		sVal = sVal & PROP_FIRSTNAME & " = " & objProfile.Item (PROP_FIRSTNAME)  & vbCrLf
		sVal = sVal & PROP_LASTNAME & " = " & objProfile.Item (PROP_LASTNAME)  & vbCrLf
		sVal = sVal & PROP_EMAILADDRESS & " = " & objProfile.Item (PROP_EMAILADDRESS)  & vbCrLf
		sVal = sVal & PROP_PASSWORD & " = " & objProfile.Item (PROP_PASSWORD)  & vbCrLf & vbCrLf
	End If

	If objWParam Is Nothing Then
		sVal = sVal & "Wizard Param is nothing" & vbCrLf & vbCrLf
	Else
		sVal = sVal & PROP_LANGUAGE & " = " & objWParam.Item (PROP_LANGUAGE)  & vbCrLf
		sVal = sVal & PROP_COMPLETION_URL & " = " & objWParam.Item (PROP_COMPLETION_URL)  & vbCrLf
		sVal = sVal & PROP_CUSTOMID & " = " & objWParam.Item (PROP_CUSTOMID)  & vbCrLf & vbCrLf
	End If

	If objApplication Is Nothing Then
		sVal = sVal & "No Application has to be registered or activated" &vbCrLf & vbCrLf
	Else
		nCount = objApplication.Count
		AppsItems = objApplication.Items

		For nCtr = 0 To nCount-1
			Set objApps = AppsItems(nCtr)

			sVal = sVal & " Application Object # " & (nCtr+1) & " # " & objApps.Item (PROP_APPCODE) & vbCrLf
			sVal = sVal & "---------------------------------------" & vbCrLf
			
			sVal = sVal & PROP_APPCAT & " = " & objApps.Item (PROP_APPCAT)  & vbCrLf
			sVal = sVal & PROP_APPCODE & " = " & objApps.Item (PROP_APPCODE)  & vbCrLf
			sVal = sVal & PROP_ACCOUNTID & " = " & objApps.Item (PROP_ACCOUNTID)  & vbCrLf
			sVal = sVal & PROP_AFFID & " = " & objApps.Item (PROP_AFFID)  & vbCrLf
			sVal = sVal & PROP_COUNTRY & " = " & objApps.Item (PROP_COUNTRY)  & vbCrLf
			sVal = sVal & PROP_LANGCODE & " = " & objApps.Item (PROP_LANGCODE)  & vbCrLf
			sVal = sVal & PROP_SYNCURL & " = " & objApps.Item (PROP_SYNCURL)  & vbCrLf
			sVal = sVal & PROP_BACKEND & " = " & objApps.Item (PROP_BACKEND)  & vbCrLf		
			sVal = sVal & PROP_EXPIRYDATE & " = " & objApps.Item (PROP_EXPIRYDATE)  & vbCrLf
			sVal = sVal & PROP_WEBSITE & " = " & objApps.Item (PROP_WEBSITE)  & vbCrLf
			sVal = sVal & PROP_SUBTYPE & " = " & objApps.Item (PROP_SUBTYPE)  & vbCrLf
			sVal = sVal & PROP_SUBSTATUS & " = " & objApps.Item (PROP_SUBSTATUS)  & vbCrLf & vbCrLf

			If PROP_REGREQUEST = strPropName Then
			'{
				Set objCData = objApps.Item (PROP_CUSTOMDATA)

				sVal = sVal & "Application's Custom Data" & vbCrLf
				sVal = sVal & "---------------------------------------" & vbCrLf
				cd = objCData.Items
				cdk = objCData.Keys

				For nCustDataCtr = 0 To objCData.Count-1
					sVal = sVal & cdk(nCustDataCtr) & " = " & cd(nCustDataCtr) & vbCrLf
				Next

			'}
			End If

			Set objApps = Nothing
		Next
	End If

	Msgbox sVal, ,strPropName
'}
End Function

Function SetTestResponse ()
'{
	Dim objRequest, objApplication, objWParam, objApps, AppsItems
	Dim objResponse, objRespApps, objRespApplication
	Dim nCustDataCtr, nCount, nCtr
	Dim sTemp, sVal, sMon, sdate, sDay

	Set objRequest = gobjExternal.GetParam ( PROP_REGREQUEST )
	Set objResponse = CreateObject ( "Scripting.Dictionary" )

	Set objApplication = objRequest.Item (PROP_APPLICATION)

	sTemp = objRequest.Item (PROP_VERSION)

	'// PROP # 1. Version
	objResponse.Add PROP_VERSION, sTemp 

	Set objRespApplication = Nothing	

	'// Result	
	objResponse.Add PROP_RESULT, 0

	If Not objApplication Is Nothing Then
		nCount = objApplication.Count
		AppsItems = objApplication.Items

		Set objRespApplication = CreateObject ( "Scripting.Dictionary" )

		For nCtr = 0 To nCount-1
			Set objApps = AppsItems(nCtr)
			Set objRespApps = CreateObject ( "Scripting.Dictionary" )

			sTemp = objApps.Item (PROP_APPCAT)			
			sVal = PROP_APPCAT & " = " & sTemp  & vbCrLf
			objRespApps.Add PROP_APPCAT, sTemp

			sTemp = objApps.Item (PROP_APPCODE)
			sVal = sVal & PROP_APPCODE & " = " & sTemp  & vbCrLf
			objRespApps.Add PROP_APPCODE, sTemp

			sTemp = "123456"
			sVal = sVal & PROP_ACCOUNTID & " = " & sTemp  & vbCrLf
			objRespApps.Add PROP_ACCOUNTID, sTemp

			sTemp = objApps.Item (PROP_AFFID)
			sVal = sVal & PROP_AFFID & " = " & sTemp & vbCrLf
			objRespApps.Add PROP_AFFID, sTemp

			sTemp = objApps.Item (PROP_COUNTRY)
			sVal = sVal & PROP_COUNTRY & " = " & sTemp  & vbCrLf
			objRespApps.Add PROP_COUNTRY, sTemp

			sTemp = objApps.Item (PROP_LANGCODE)
			sVal = sVal & PROP_LANGCODE & " = " & sTemp  & vbCrLf
			objRespApps.Add PROP_LANGCODE, sTemp

			sTemp = "msc_sync_url.asp"
			sVal = sVal & PROP_SYNCURL & " = " & sTemp  & vbCrLf
			objRespApps.Add PROP_SYNCURL, sTemp

			sTemp = gobjExternal.GetParam ( PROP_BACKEND )
			sVal = sVal & PROP_BACKEND & " = " & sTemp  & vbCrLf		
			objRespApps.Add PROP_BACKEND, sTemp

			sTemp =  DateAdd ( "d", 90, Date )
			sVal = sVal & PROP_EXPIRYDATE & " = " & sTemp  & vbCrLf
			objRespApps.Add PROP_EXPIRYDATE, sTemp

			sTemp = "us.mcafee.com"
			sVal = sVal & PROP_WEBSITE & " = " & sTemp  & vbCrLf
			objRespApps.Add PROP_WEBSITE, sTemp
			
			sTemp = 1
			sVal = sVal & PROP_SUBTYPE & " = " & sTemp  & vbCrLf
			objRespApps.Add PROP_SUBTYPE, sTemp

			sTemp = 1
			sVal = sVal & PROP_SUBSTATUS & " = " & sTemp  & vbCrLf
			objRespApps.Add PROP_SUBSTATUS, sTemp

			objRespApplication.Add objApps.Item (PROP_APPCODE), objRespApps

			Set objApps = Nothing
			Set objRespApps = Nothing
		Next
	End If

	'// PROP # 3. Application
	objResponse.Add PROP_APPLICATION, objRespApplication

	'// PROP # 4. Completed Url Message
	objResponse.Add PROP_COMPLETED_MSG, STR_COMPLETED_MSG

	Call gobjExternal.SetParam ( PROP_REGRESPONSE, objResponse )

'}
End Function

Function PerformPostReg ( sIni, sWebSite )
'{
	Dim sVal, sKey, sName, sRegVal, sValue, sRegArgsSplit
	Dim sValSplit, sRegValArgs, sTemp, sRegRelativeUrl
	Dim nPos, nCount, nIdx
	Dim bOldObfuscate

	sVal = gobjReg.IniGetMultipleValues( sIni, SECTION_POSTREG )

	bOldObfuscate = gobjReg.Obfuscate

	gobjReg.AllowEveryone = True
	gobjReg.Obfuscate = False

	For nIdx = LBound(sVal) To UBound(sVal)
	'{
		sValue = LCase(sVal(nIdx, 1))
		sName = LCase(sVal(nIdx, 0))

		If InStr (sName, "$reg$") > 0 Then
		'{
			sValSplit = split (sValue, ",")
			
			sName = Trim(sValSplit(1))
			sKey = Trim(sValSplit(0))

			sRegVal = LCase(Trim(gobjReg.RegQueryValue ( sKey, sName )))

			If "" <> sRegVal Then
			'{
				nPos = InStr (sRegVal, "?")
				If nPos > 0 Then
					sRegValArgs = Trim(Mid (sRegVal, nPos+1))
					sRegVal = Left ( sRegVal, nPos-1)
				End If

				sRegRelativeUrl = ""
				nPos = InStr (sRegVal, "//")

				If 0 < nPos Then sRegRelativeUrl = Mid (sRegVal, nPos+2)

				If "" <> sRegRelativeUrl Then
				'{
					nPos = InStr (sRegRelativeUrl, "/")
					If 0 < nPos Then sRegRelativeUrl = Mid (sRegRelativeUrl, nPos)
				'}
				End If

				If "" = sRegRelativeUrl Then sRegRelativeUrl = sRegVal
				
				sTemp = "http://" & sWebSite & sRegRelativeUrl
				sValue = ""

				If "" <> sRegValArgs Then
				'{
					sRegArgsSplit = split (sRegValArgs, "&")

			
					For nCount = 0 To UBound(sRegArgsSplit)
					'{
						nPos = InStr (sRegArgsSplit(nCount),LCase(EXCLUSION_LIST_PARAMS))
						If nPos <= 0 Then
						'{
							sValue = sValue & sRegArgsSplit(nCount) & "&"
						'}
						End If
					'}
					Next
				'}
				End If

				If "" <> sValue Then
				'{
					If Right (sValue, 1) = "&" Then sValue = Left (sValue, Len(sValue)-1)
	
					sValue = sTemp & "?" & sValue
				'}
				Else
				'{
					sValue = sTemp
				'}
				End If

				Call gobjReg.RegSetValue ( sKey, sName, CStr(sValue) )
			'}
			End If
		'}
		End If
	'}
	Next

	gobjReg.Obfuscate = bOldObfuscate
'}
End Function

Function GetObjectPath( sCLSID, sRelativeFileDir, sFileName )
'{
	Dim   sPath

	sPath = gobjOS.GetObjectModuleDir( sCLSID )
	If "" = sPath Then
	'{
		sPath = GetProgramFilesDir() & sRelativeFileDir
		If False = gobjFS.IsFile( sPath & sFileName ) Then
		'{
			GetObjectPath = ""
			Exit Function
		'}
		End If
	'}
	End If

	GetObjectPath = gobjFS.GetShortPathName( sPath )
'}
End Function

Function LaunchWOW ( strWowExe, strArgs )
'{
	Dim bShowWOW

	bShowWOW = gobjExternal.GetParam ( PROP_SHOW_WOW )

	If True = bShowWOW Then
	'{
		Call LaunchMSCExe (strWowExe, strArgs)
		Call gobjExternal.SetParam ( PROP_SHOW_WOW, False )
	'}
	End If 
'}
End Function

Function ShowPostWOW()
'{
	Dim bShowWOW

'	bShowWOW = gobjExternal.GetParam ( PROP_SHOW_WOW )

	LogDetails ( "Close main window" )
	Call CloseWindow()

'}
End Function

Function LaunchMSCExe( strExeName, strArgs )
'{
	Dim strAgentDir

	If IsObject(gobjOS) Then
	'{
		strAgentDir = gobjOS.GetObjectModuleDir( CLSID_MCAgent )

		If "" <> strAgentDir Then
		'{
			Call gobjOS.RunProgram( CStr(strAgentDir & "\" & strExeName), CStr(strArgs) )
		'}
		End If
	'}
	End If
'}
End Function

Function GetResponseSubscriptionInfo ( objApp, objSubInfo )
'{
	Dim sTemp

	GetResponseSubscriptionInfo = REGWIZ_SUCCESS

	If IsObject ( objSubInfo ) Then
	'{
		objSubInfo.AppId     = objApp.Item (PROP_APPCAT)
		objSubInfo.AppCode	 = objApp.Item (PROP_APPCODE)

		sTemp = objApp.Item (PROP_ACCOUNTID)
		If "" <> sTemp Then objSubInfo.AccountId = sTemp

		objSubInfo.ExpiryDate = objApp.Item (PROP_EXPIRYDATE)

		sTemp = objApp.Item (PROP_SYNCURL)
		If "" <> sTemp Then objSubInfo.SyncUrl = sTemp

		sTemp = objApp.Item (PROP_WEBSITE)
		If "" <> sTemp Then objSubInfo.WebSite = sTemp

		sTemp = objApp.Item (PROP_BACKEND)
		If "" <> sTemp Then objSubInfo.Backend = sTemp

		sTemp = objApp.Item (PROP_AFFID)
		If "" <> sTemp Then objSubInfo.affId = sTemp

		Select Case CLng(objApp.Item (PROP_SUBTYPE))
		'{
			Case 1
				objSubInfo.Perpetual = 0
			Case 5
				objSubInfo.Perpetual = 1
		'}
		End Select

		Select Case CLng(objApp.Item (PROP_SUBSTATUS))
		'{
			Case 1
				objSubInfo.Trial = 1
			Case 2
				objSubInfo.Trial = 0
		'}
		End Select

		'// Renewal Url is not available as part of response object. DBVersion is not written.
	'}
	End If
'}
End Function

Function FallBackToFactorySettings()
'{
	Dim sTemp, sAgentDir, sDate, sRegWizDir
	Dim objRegWiz
	Dim nStatus

	nStatus = REGWIZ_ONREBOOT
	sAgentDir = GetAgentDir()
	
	sTemp = Trim(gobjReg.IniGetValue( CStr(sAgentDir & FACTORY_SETTINGS_INI), SECTION_SETTINGS, KEY_ACTION ))

	If "" <> sTemp Then
	'{
		nStatus = CLng(sTemp)

		If 2 = nStatus Then
		'{
			sTemp = ""
			sTemp = Trim(gobjReg.IniGetValue( CStr(sAgentDir & FACTORY_SETTINGS_INI), SECTION_FREQUENCY, KEY_DAYS ))

			If "" = sTemp Then
			'{
				sTemp = "1"
			'}
			End If
			sDate = FormatNextRun ( Clng(sTemp) )

			Set objRegWiz = gobjExternal.GetParam(MCREGWIZ_INTERFACE_NAME)

			If IsObject (objRegWiz) Then
			'{
				objRegWiz.NextRun = sDate
				
				sRegWizDir = GetRegWizDataDir()

				Call gobjReg.IniWriteValue( CStr(sRegWizDir & MCREGWIZ_INI), SECTION_REGWIZ, KEY_WHENCONNECTED, CStr("") )
				Call gobjReg.IniWriteValue( CStr(sRegWizDir & MCREGWIZ_INI), SECTION_REGWIZ, KEY_NEXTRUN, CStr(sDate) )
			'}
			End If
			
			nStatus = REGWIZ_NEXTRUN
		'}
		End If
	'}
	End If

	FallBackToFactorySettings = nStatus
'}
End Function

Function SubmitDataForRegistration( strMode )
'{
	Dim bInternetConnection, strRegUrl

	bInternetConnection = gobjOS.InternetGetConnectedState()

	strRegUrl = gobjExternal.GetParam ( PROP_REGURL )
	strRegUrl = strRegUrl & strMode

	SubmitDataForRegistration = REGWIZ_STATUS_NOINTERNET

	If True = bInternetConnection Then
	'{
		SubmitDataForRegistration = REGWIZ_STATUS_SUCCESS
		Call window.location.replace (CStr(strRegUrl))
	'}
	Else
	'{
		SubmitDataForRegistration = REGWIZ_STATUS_NOINTERNET
	'}
	End If
'}
End Function

Function LogDetails ( strLog )
'{
	Dim bObfuscate
	Dim nCount, sName

	bObfuscate = gobjReg.Obfuscate

	gobjReg.AllowEveryone = True
	gobjReg.Obfuscate = False

	Call gobjReg.RegCreateKey ( REG_REGWIZ_LOG_KEY )
	
	nCount = gobjReg.RegQueryValue( REG_REGWIZ_LOG_KEY, REG_REGWIZ_LOG_COUNT_NAME )
	If 0 = VarType(nCount) Then
	    nCount = 0
	Else
		nCount = nCount + 1
	End If

	If nCount < 10 Then
		sName = CStr(REG_REGWIZ_LOG_COUNT_PREFIX & "00" & CLng(nCount))
	ElseIf nCount < 100 Then
		sName = CStr(REG_REGWIZ_LOG_COUNT_PREFIX & "0" & CLng(nCount))
	Else
		sName = CStr(REG_REGWIZ_LOG_COUNT_PREFIX & CLng(nCount))
	End If

	If 0 = gobjReg.RegSetValue( REG_REGWIZ_LOG_KEY, CStr(sName), CStr(strLog) ) Then
		call gobjReg.RegSetValue( REG_REGWIZ_LOG_KEY, REG_REGWIZ_LOG_COUNT_NAME, CLng(nCount) )
	End If

	gobjReg.Obfuscate = bObfuscate	 
'}
End Function

Function IsBootCountZero()
'{
	Dim nBootCount
	
	IsBootCountZero = True

	nBootCount = gobjReg.RegQueryValue (REG_AGENT, REG_KEY_REGWIZ_BOOT_COUNT)
	
	If "" <> Trim(CStr(nBootCount)) Then
	'{
		nBootCount = CLng(nBootCount)

		If (1 <= nBootCount) Then
			nBootCount = nBootCount - 1
		Else
			nBootCount = 0
		End If

		If (0 <> nBootCount) Then
		'{
			Call gObjReg.RegSetValue (REG_AGENT, REG_KEY_REGWIZ_BOOT_COUNT, Clng(nBootCount))
			IsBootCountZero = False
		'}
		End If
	'}
	End If
'}
End Function

Function ShowOptinPage()
'{
	Dim sOemIni, strShowOptin

	ShowOptinPage = False

	sOemIni = GetAgentDir()
	sOemIni = sOemIni & OEM_INI_WSLASH

	strShowOptin = Trim (gobjReg.IniGetValue (sOemIni, SECTION_CUSTOM, KEY_SHOW_OPTIN))
	
	If "1" = CStr(strShowOptin) Then
	'{
		ShowOptinPage = True
	'}
	End If
'}
End Function

Function CanShowPage( strKey )
'{
	Dim sOemIni, strShowPage

	CanShowPage = False

	sOemIni = GetAgentDir()
	sOemIni = sOemIni & OEM_INI_WSLASH

	strShowPage = Trim (gobjReg.IniGetValue (sOemIni, SECTION_CUSTOM, strKey))
	
	If "1" = CStr(strShowPage) Then
	'{
		CanShowPage = True
	'}
	End If
'}
End Function

Function ShowPrivacyPolicy()
'{
	'On Error Resume Next

	Dim bInternetConnection, objWindow, strUrl, strPrivacyPolicyLCode

	bInternetConnection = False
	bInternetConnection = gobjOS.InternetGetConnectedState()

	If False = bInternetConnection Then
	'{
		MsgBox STR_CONNECT_TO_INTERNET, VBSystemModal Or VBInformation Or VBOKOnly, STR_APP_ERROR_TITLE
		Exit Function
	'}
	End If

	strPrivacyPolicyLCode = GetLangCodeForPrivacyPolicy( gsEulaLang )
	strUrl = STR_PRIVACY_POLICY_URL & strPrivacyPolicyLCode

	Set objWindow = openNoScrollWindow(strUrl, "_McAfeePrivacyPolicy", "720", "680")

	If (IsObject(objWindow)) And (Not objWindow Is Nothing) Then
	'{
		objWindow.focus()
	'}
	End If
'}
End Function

Function SetStyleSheet()
'{
	If "jp" = LANG_CHARSET Or "ja" = LANG_CHARSET Then
		document.write "<link rel='stylesheet' type='text/css' href='stylesjp.css'>"
	Else
		document.write "<link rel='stylesheet' type='text/css' href='styles.css'>"
	End If
'}
End Function

Function SetFirstNameLastNameOrder()
'{
	document.write "<tr>"
	document.write "<td nowrap='true' width='45%'>"

	If "ja" = LCase(LANG_CHARSET) Or "jp" = LCase(LANG_CHARSET) Then
	'{
		document.write "<span id='idLN'> " & STR_LAST_NAME & " </span></td>" & chr(10)
		document.write "<td align='left' width='55%'>" & chr(10)
		document.write "<input type='text' id='txtLName' name='txtLName' value='' maxlength='20' style='width:150px' /></td>" & chr(10)
		document.write "</tr>" & chr(10)
		document.write "<tr>" & chr(10)
		document.write "<td nowrap='true' width='45%'>" & chr(10)
		document.write "<span id='idFN'> " & STR_FIRST_NAME & " </span></td>" & chr(10)
		document.write "<td align='left' width='55%'>" & chr(10)
		document.write "<input type='text' id='txtFName' name='txtFName' value='' maxlength='20' style='width:150px' /></td>" & chr(10)
	'}
	Else
	'{
		document.write "<span id='idFN'> " & STR_FIRST_NAME & " </span></td>" & chr(10)
		document.write "<td align='left' width='55%'>" & chr(10)
		document.write "<input type='text' id='txtFName' name='txtFName' value='' maxlength='20' style='width:150px' /></td>" & chr(10)
		document.write "</tr>" & chr(10)
		document.write "<tr>" & chr(10)
		document.write "<td nowrap='true' width='45%'>" & chr(10)
		document.write "<span id='idLN'> " & STR_LAST_NAME & " </span></td>" & chr(10)
		document.write "<td align='left' width='55%'>" & chr(10)
		document.write "<input type='text' id='txtLName' name='txtLName' value='' maxlength='20' style='width:150px' /></td>" & chr(10)
	'}
	End If

	document.write "</tr>"
'}
End Function
